#!/usr/bin/perl
#
#
# Copyright Michigan State University Board of Trustees
# $Id
#
# This file is part of the LearningOnline Network with CAPA (LON-CAPA).
#
# LON-CAPA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# LON-CAPA is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with LON-CAPA; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# /home/httpd/cgi-bin/decompress.pl
#
# http://www.lon-capa.org/
#
# The LearningOnline Network with CAPA
#
# A CGI script that decompresses compressed files for mass uploading into
# construction space
####
use strict;
use lib '/home/httpd/lib/perl';
use LONCAPA::loncgi ();
if(! &LONCAPA::loncgi::check_cookie_and_load_env()) {
    print "Content-type: text/html\n\n";
    print <<END;
    <html><body>NO COOKIE!</body></html>
END
} else {
    print "Content-type: text/html\n\n";
    if(! $ENV{'cgi.file'} || ! $ENV{'cgi.dir'}) {
        print <<END;
        <html><body>Bad Enviroment!</body></html>
END
    } else {
        print <<END;
	<html><body><b>Output of decompress:</b><br /><br />
END
        chdir $ENV{'cgi.dir'};
        if ($ENV{'cgi.file'} =~ m|\.zip$|i) {
            open(OUTPUT, "unzip -o $ENV{'cgi.file'} 2> /dev/null |");
            while (<OUTPUT>) {
                print "$_<br />";
            }
            close(OUTPUT);
        } elsif ($ENV{'cgi.file'} =~ m|\.tar\.gz$|i) {
            open(OUTPUT, "tar -zxpvf $ENV{'cgi.file'} 2> /dev/null |");
            while (<OUTPUT>) {
                print "$_<br />";
            }
            close(OUTPUT);
        } elsif ($ENV{'cgi.file'} =~ m|\.tar\.bz2$|i) {
            open(OUTPUT, "tar -jxpvf $ENV{'cgi.file'} 2> /dev/null |");
            while (<OUTPUT>) {
                print "$_<br />";
            }
            close(OUTPUT);
        } elsif ($ENV{'cgi.file'} =~ m|\.bz2$|i) {
            open(OUTPUT, "bunzip2 $ENV{'cgi.file'} 2> /dev/null |");
            while (<OUTPUT>) {
                print "$_<br />";
            }
            close(OUTPUT);
        } elsif ($ENV{'cgi.file'} =~ m|\.tgz$|i) {
            open(OUTPUT, "tar -zxpvf $ENV{'cgi.file'} 2> /dev/null |");
            while (<OUTPUT>) {
                print "$_<br />";
            }
            close(OUTPUT);
        } elsif ($ENV{'cgi.file'} =~ m|\.gz$|i) {
            open(OUTPUT, "gunzip $ENV{'cgi.file'} 2> /dev/null |");
            while (<OUTPUT>) {
                print "$_<br />";
            }
            close(OUTPUT);
        } elsif ($ENV{'cgi.file'} =~ m|\.tar$|i) {
            open(OUTPUT, "tar -xpvf $ENV{'cgi.file'} 2> /dev/null |");
            while (<OUTPUT>) {
                print "$_<br />";
            }
            close(OUTPUT);
        } else {
            print "There has been an error in determining the file type of $ENV{'cgi.file'}, please check name";
        }
        print "<br /><b>Decompress complete!</b><br /></body></html>";
    }
}

